﻿' RotonAct
'
' Contains all action code. This code is executed whenever a Thing cycles.



Partial Public Class Environment

    Protected Sub Act(ByVal Index As Integer)
        Dim T As Thing = CurrentBoard.Things(Index)
        Dim E As Element = ElementAt(T.X, T.Y)

        Select Case E.ID
            Case ElementID.Bear
                ActBear(Index)
            Case ElementID.BlinkWall
                ActBlinkWall(Index)
            Case ElementID.Bomb
                ActBomb(Index)
            Case ElementID.Bullet
                ActBullet(Index)
            Case ElementID.Clockwise
                ActClockwise(Index)
            Case ElementID.Counter
                ActCounter(Index)
            Case ElementID.DragonPup
                ActDragonPup(Index)
            Case ElementID.Duplicator
                ActDuplicator(Index)
            Case ElementID.Head
                ActHead(Index)
            Case ElementID.Lion
                ActLion(Index)
            Case ElementID.Monitor
                ActMonitor(Index)
            Case ElementID.Object
                ActObject(Index)
            Case ElementID.Pairer
                ActPairer(Index)
            Case ElementID.Player
                ActPlayer(Index)
            Case ElementID.Pusher
                ActPusher(Index)
            Case ElementID.Roton
                ActRoton(Index)
            Case ElementID.Ruffian
                ActRuffian(Index)
            Case ElementID.Scroll
                ActScroll(Index)
            Case ElementID.Segment
                ActSegment(Index)
            Case ElementID.Shark
                ActShark(Index)
            Case ElementID.Slime
                ActSlime(Index)
            Case ElementID.Spider
                ActSpider(Index)
            Case ElementID.SpinningGun
                ActSpinningGun(Index)
            Case ElementID.Star
                ActStar(Index)
            Case ElementID.Stone
                ActStone(Index)
            Case ElementID.Tiger
                ActTiger(Index)
            Case ElementID.Transporter
                ActTransporter(Index)
        End Select
    End Sub

    Protected Sub ActBear(ByVal Index As Integer)
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim V As Vector
        Dim E As Element
        Dim T As Thing = CurrentBoard.Things(Index)

        If (PlayerX = T.X) OrElse (8 - T.P1 < AbsDiff(PlayerY, T.Y)) Then
            If (8 - T.P1 < AbsDiff(PlayerX, T.X)) Then
                V.X = 0
                V.Y = 0
            Else
                V.X = 0
                V.Y = PosNeg(PlayerY - T.Y)
            End If
        Else
            V.X = PosNeg(PlayerX - T.X)
            V.Y = 0
        End If
        TargetX = T.X + V.X
        TargetY = T.Y + V.Y
        E = ElementAt(TargetX, TargetY)
        If (E.Floor) Then
            MoveThing(Index, TargetX, TargetY)
        ElseIf (E.ID = ElementID.Player) OrElse (E.ID = ElementID.Breakable) Then
            Attack(Index, TargetX, TargetY)
        End If
    End Sub

    Protected Sub ActBlinkWall(ByVal Index As Integer)
        Dim Blocked As Boolean
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim E As Element
        Dim Color As Integer
        Dim I As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        With T
            If (.P3 = 0) Then
                .P3 = .P1 + 1
            End If
            If (.P3 = 1) Then
                .P3 = (.P2 * 2) + 1
                TargetX = .X + .XStep
                TargetY = .Y + .YStep
                If (.XStep = 0) Then
                    E = Library.GetElementFromID(ElementID.BlinkRayV)
                Else
                    E = Library.GetElementFromID(ElementID.BlinkRayH)
                End If
                Color = ColorAt(T.X, T.Y)
                Do While (ElementAt(TargetX, TargetY).ID = E.ID) AndAlso (ColorAt(TargetX, TargetY) = Color)
                    ElementAt(TargetX, TargetY) = Library.GetElementFromID(ElementID.Empty)
                    UpdateAt(TargetX, TargetY)
                    TargetX += .XStep
                    TargetY += .YStep
                Loop
                If (TargetX = .X + .XStep) AndAlso (TargetY = .Y + .YStep) Then
                    Blocked = False
                    Do
                        If (ElementAt(TargetX, TargetY).Destructible) Then
                            DestroyAt(TargetX, TargetY)
                        End If
                        If (ElementAt(TargetX, TargetY).ID = ElementID.Player) Then
                            I = ThingIndexAt(TargetX, TargetY)
                            If (.YStep = 0) Then
                                If (ElementAt(TargetX, TargetY - 1).ID = ElementID.Empty) Then
                                    MoveThing(I, TargetX, TargetY - 1)
                                ElseIf (ElementAt(TargetX, TargetY + 1).ID = ElementID.Empty) Then
                                    MoveThing(I, TargetX, TargetY + 1)
                                End If
                            Else
                                If (ElementAt(TargetX + 1, TargetY).ID = ElementID.Empty) Then
                                    MoveThing(I, TargetX + 1, TargetY)
                                ElseIf (ElementAt(TargetX - 1, TargetY).ID = ElementID.Empty) Then
                                    MoveThing(I, TargetX + 1, TargetY)
                                End If
                            End If
                            If (ElementAt(TargetX, TargetY).ID = ElementID.Player) Then
                                Do Until (World.Health <= 0)
                                    HarmThing(0)
                                Loop
                                Blocked = True
                            End If
                        End If
                        If (ElementAt(TargetX, TargetY).ID = ElementID.Empty) Then
                            TileAt(TargetX, TargetY) = New Tile(E, Color)
                            UpdateAt(TargetX, TargetY)
                        Else
                            Blocked = True
                        End If
                        TargetX += .XStep
                        TargetY += .YStep
                    Loop Until (Blocked)
                End If
            Else
                .P3 -= 1
            End If
        End With
    End Sub

    Protected Sub ActBomb(ByVal Index As Integer)
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        If (T.P1 > 0) Then
            T.P1 -= 1
            UpdateAt(T.X, T.Y)
            If (T.P1 = 1) Then
                PlaySound(1, SoundBank.BombExplode)
                Radius(T.X, T.Y, RadiusType.Explode)
            ElseIf (T.P1 = 0) Then
                TargetX = T.X
                TargetY = T.Y
                RemoveThing(Index)
                Radius(TargetX, TargetY, RadiusType.Cleanup)
            Else
                If (T.P1 Mod 2 = 0) Then
                    PlaySound(1, SoundBank.BombTock)
                Else
                    PlaySound(1, SoundBank.BombTick)
                End If
            End If
        End If
    End Sub

    Protected Sub ActBullet(ByVal Index As Integer)
        Dim Ricochet As Boolean
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim E As Element
        Dim I As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        Ricochet = True
        Do
            TargetX = T.X + T.XStep
            TargetY = T.Y + T.YStep
            E = ElementAt(TargetX, TargetY)
            If (E.Floor) OrElse (E.ID = ElementID.Water) OrElse (E.ID = ElementID.Lava) Then
                MoveThing(Index, TargetX, TargetY)
                Exit Do
            End If
            If (E.ID = ElementID.Ricochet) AndAlso (Ricochet) Then
                PlaySound(1, SoundBank.Ricochet)
                T.XStep = -T.XStep
                T.YStep = -T.YStep
                Ricochet = False
                Continue Do
            End If
            If (E.ID <> ElementID.Breakable) Then
                If (Not E.Destructible) OrElse ((E.ID <> ElementID.Player) AndAlso (T.P1 <> 0)) Then
                    If (Ricochet) AndAlso (ElementAt(T.X + T.YStep, T.Y + T.XStep).ID = ElementID.Ricochet) Then
                        PlaySound(1, SoundBank.Ricochet)
                        I = T.XStep
                        T.XStep = -T.YStep
                        T.YStep = -I
                        Ricochet = False
                        Continue Do
                    ElseIf (Ricochet) AndAlso (ElementAt(T.X - T.YStep, T.Y - T.XStep).ID = ElementID.Ricochet) Then
                        PlaySound(1, SoundBank.Ricochet)
                        I = T.XStep
                        T.XStep = T.YStep
                        T.YStep = I
                        Ricochet = False
                        Continue Do
                    Else
                        RemoveThing(Index)
                        State.ActIndex -= 1
                        If (E.ID = ElementID.Object) Then
                            'SHOT
                            SendLabel(-ThingIndexAt(TargetX, TargetY), OOPCodeSet(KnownCommand.Shot), False)
                        End If
                        Exit Do
                    End If
                End If
            End If
            If (E.Score > 0) Then
                World.Score += E.Score
                StatusUpdate()
            End If
            Attack(Index, TargetX, TargetY)
            Exit Do
        Loop
    End Sub

    Protected Sub ActClockwise(ByVal Index As Integer)
        Dim T As Thing = CurrentBoard.Things(Index)
        UpdateAt(T.X, T.Y)
        ConveyorMove(T.X, T.Y, -1)
    End Sub

    Protected Sub ActCounter(ByVal Index As Integer)
        Dim T As Thing = CurrentBoard.Things(Index)
        UpdateAt(T.X, T.Y)
        ConveyorMove(T.X, T.Y, 1)
    End Sub

    Protected Sub ActDragonPup(ByVal Index As Integer)
        Dim T As Thing = CurrentBoard.Things(Index)
        UpdateAt(T.X, T.Y)
    End Sub

    Protected Sub ActDuplicator(ByVal Index As Integer)
        Dim SourceX As Integer
        Dim SourceY As Integer
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim I As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        With T
            SourceX = .X + .XStep
            SourceY = .Y + .YStep
            TargetX = .X - .XStep
            TargetY = .Y - .YStep
            If (.P1 > 4) Then
                If (ElementAt(TargetX, TargetY).ID = ElementID.Player) Then
                    Interact(SourceX, SourceY, 0, State.KeyVectorX, State.KeyVectorY)
                    T = CurrentBoard.Things(Index)
                Else
                    If (ElementAt(TargetX, TargetY).ID <> ElementID.Empty) Then
                        Push(TargetX, TargetY, New Vector(-.XStep, -.YStep))
                        If (Not Parameters.KoopoBug) Then
                            Index = CurrentBoard.Things.IndexOf(T)
                        End If
                        T = CurrentBoard.Things(Index)
                    End If
                    If (ElementAt(TargetX, TargetY).ID = ElementID.Empty) Then
                        I = ThingIndexAt(SourceX, SourceY)
                        If (I > 0) Then
                            If (ThingCount < Parameters.MaxThings) Then
                                With TileAt(SourceX, SourceY)
                                    SpawnThing(TargetX, TargetY, .Element, .Color, .Element.Cycle, CurrentBoard.Things(I))
                                    UpdateAt(TargetX, TargetY)
                                End With
                            End If
                        ElseIf (I <> 0) Then
                            TileAt(TargetX, TargetY) = TileAt(SourceX, SourceY)
                            UpdateAt(TargetX, TargetY)
                        End If
                        PlaySound(3, SoundBank.Duplicate)
                    Else
                        PlaySound(3, SoundBank.DuplicateFail)
                    End If
                End If
                .P1 = 0
            Else
                .P1 += 1
            End If
            UpdateAt(.X, .Y)
            .Cycle = (9 - .P2) * 3
        End With
    End Sub

    Protected Sub ActHead(ByVal Index As Integer)
        Dim E As Element
        Dim V As Vector
        Dim I As Integer
        Dim SourceX As Integer
        Dim SourceY As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        If (PlayerX = T.X) AndAlso (T.P1 > Random(10)) Then
            T.XStep = 0
            T.YStep = PosNeg(PlayerY - T.Y)
        ElseIf (PlayerY = T.Y) AndAlso (T.P1 > Random(10)) Then
            T.XStep = PosNeg(PlayerX - T.X)
            T.YStep = 0
        ElseIf ((T.XStep = 0) AndAlso (T.YStep = 0)) OrElse (T.P2 > (Random(10) << 2)) Then
            T.Vector = Rnd()
        End If
        E = ElementAt(T.X + T.XStep, T.Y + T.YStep)
        V = T.Vector
        If (Not E.Floor) AndAlso (E.ID <> ElementID.Player) Then
            T.Vector = RndP(T.Vector)
            E = ElementAt(T.X + T.XStep, T.Y + T.YStep)
            If (Not E.Floor) AndAlso (E.ID <> ElementID.Player) Then
                T.Vector = T.Vector.Opp
                E = ElementAt(T.X + T.XStep, T.Y + T.YStep)
                If (Not E.Floor) AndAlso (E.ID <> ElementID.Player) Then
                    T.Vector = V.Opp
                    E = ElementAt(T.X + T.XStep, T.Y + T.YStep)
                    If (Not E.Floor) AndAlso (E.ID <> ElementID.Player) Then
                        T.XStep = 0
                        T.YStep = 0
                    End If
                End If
            End If
        End If
        If (T.XStep = 0) AndAlso (T.YStep = 0) Then
            ElementAt(T.X, T.Y) = Library.GetElementFromID(ElementID.Segment)
            UpdateAt(T.X, T.Y)
            'T.Leader = -1
            Do
                With CurrentBoard.Things(Index)
                    I = .Follower
                    .Follower = .Leader
                    .Leader = I
                End With
                If (I > 0) Then
                    Index = I
                Else
                    Exit Do
                End If
            Loop
            T = CurrentBoard.Things(Index)
            ElementAt(T.X, T.Y) = Library.GetElementFromID(ElementID.Head)
            UpdateAt(T.X, T.Y)
        Else
            If (ElementAt(T.X + T.XStep, T.Y + T.YStep).ID = ElementID.Player) Then
                If (T.Follower > 0) Then
                    With CurrentBoard.Things(T.Follower)
                        ElementAt(.X, .Y) = Library.GetElementFromID(ElementID.Head)
                        .Leader = -1
                        UpdateAt(.X, .Y)
                    End With
                End If
                T.Follower = -1
                T.Leader = -1
                Attack(Index, T.X + T.XStep, T.Y + T.YStep)
            Else
                MoveThing(Index, T.X + T.XStep, T.Y + T.YStep)
                Do
                    T = CurrentBoard.Things(Index)
                    SourceX = T.X - T.XStep
                    SourceY = T.Y - T.YStep
                    V.X = T.XStep
                    V.Y = T.YStep
                    If (T.Follower < 0) Then
                        If (ElementAt(SourceX - V.X, SourceY - V.Y).ID = ElementID.Segment) AndAlso (ThingAt(SourceX - V.X, SourceY - V.Y).Leader <= 0) Then
                            T.Follower = ThingIndexAt(SourceX - V.X, SourceY - V.Y)
                        ElseIf (ElementAt(SourceX - V.Y, SourceY - V.X).ID = ElementID.Segment) AndAlso (ThingAt(SourceX - V.Y, SourceY - V.X).Leader <= 0) Then
                            T.Follower = ThingIndexAt(SourceX - V.Y, SourceY - V.X)
                        ElseIf (ElementAt(SourceX + V.Y, SourceY + V.X).ID = ElementID.Segment) AndAlso (ThingAt(SourceX + V.Y, SourceY + V.X).Leader <= 0) Then
                            T.Follower = ThingIndexAt(SourceX + V.Y, SourceY + V.X)
                        Else
                            T.Follower = -1
                        End If
                    End If
                    If (T.Follower > 0) Then
                        With CurrentBoard.Things(T.Follower)
                            .Leader = Index
                            .P1 = T.P1
                            .P2 = T.P2
                            .XStep = SourceX - .X
                            .YStep = SourceY - .Y
                        End With
                        MoveThing(T.Follower, SourceX, SourceY)
                    End If
                    Index = T.Follower
                Loop Until (Index <= 0)
            End If
        End If
    End Sub

    Protected Sub ActLion(ByVal Index As Integer)
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim V As Vector
        Dim E As Element
        Dim T As Thing = CurrentBoard.Things(Index)

        If (T.P1 >= RNG.Next(10)) Then
            V = Seek(T.X, T.Y)
        Else
            V = Rnd()
        End If
        TargetX = T.X + V.X
        TargetY = T.Y + V.Y
        E = ElementAt(TargetX, TargetY)
        If (E.Floor) Then
            MoveThing(Index, TargetX, TargetY)
        ElseIf (E.ID = ElementID.Player) Then
            Attack(Index, TargetX, TargetY)
        End If
    End Sub

    Protected Sub ActMonitor(ByVal Index As Integer)
        Dim T As Thing = CurrentBoard.Things(Index)
        If (State.KeyPressed <> 0) Then
            State.BreakGameLoop = True
        End If
        MoveRiver(Index)
    End Sub

    Protected Sub ActObject(ByVal Index As Integer)
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim Dead As Boolean = False
        Dim T As Thing = CurrentBoard.Things(Index)

        If (Not (T.Code Is Nothing)) AndAlso ((T.CurrentInstruction >= 0) OrElse (Not (MainOOPState Is Nothing))) AndAlso ((Not Parameters.MultiMovement) OrElse (T.P2 = 0)) Then
            ExecuteOOP(Index, T.CurrentInstruction, "Interaction")
        End If
        If (Not Scroll.Visible) Then
            If (T.XStep <> 0) OrElse (T.YStep <> 0) Then
                TargetX = T.X + T.XStep
                TargetY = T.Y + T.YStep
                If (Parameters.MultiMovement) AndAlso (Not ElementAt(TargetX, TargetY).Floor) Then
                    Push(TargetX, TargetY, T.Vector)
                    If (Not Parameters.KoopoBug) Then
                        Index = CurrentBoard.Things.IndexOf(T)
                    End If
                    T = CurrentBoard.Things(Index)
                End If
                If (ElementAt(TargetX, TargetY).Floor) Then
                    MoveThing(Index, TargetX, TargetY)
                    If ((Parameters.MultiMovement) AndAlso (T.P2 <> 0)) Then
                        T.P2 -= 1
                        If (T.P2 = 0) Then
                            T.XStep = 0
                            T.YStep = 0
                        End If
                    End If
                Else
                    If (Not Parameters.MultiMovement) OrElse (T.P2 = 0) Then
                        'THUD
                        SendLabel(-Index, OOPCodeSet(KnownCommand.Thud), False)
                    End If
                End If
            Else
                If ((Parameters.MultiMovement) AndAlso (T.P2 <> 0)) Then
                    T.P2 -= 1
                End If
            End If
        End If
    End Sub

    Protected Sub ActPairer(ByVal Index As Integer)
        'pairers do nothing
    End Sub

    Protected Sub ActPlayer(ByVal Index As Integer)
        Dim E As Element
        Dim Count As Integer
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim OldBoard As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        UpdateAt(T.X, T.Y)
        E = Library.GetElementFromID(ElementID.Player)
        If (World.EnergyCycles > 0) Then
            With E
                If (.Char = 2) Then
                    .Char = 1
                Else
                    .Char = 2
                End If
            End With
            If (State.GameTick Mod 2 = 0) Then
                ColorAt(T.X, T.Y) = (((State.GameTick Mod 7) + 1) << 4) + &HF
            Else
                ColorAt(T.X, T.Y) = &HF
            End If
            UpdateAt(T.X, T.Y)
        ElseIf (ColorAt(T.X, T.Y) <> E.Color) OrElse (E.Char <> 2) Then
            E.Char = 2
            If (Parameters.ForcePlayerColor) Then
                ColorAt(T.X, T.Y) = E.Color
            End If
            UpdateAt(T.X, T.Y)
        End If
        If (State.KeyPressed = &H20) Then
            State.KeyVectorX = State.LastKeyVectorX
            State.KeyVectorY = State.LastKeyVectorY
            State.KeyShift = True
        End If
        If (World.Health <= 0) Then
            State.KeyVectorX = 0
            State.KeyVectorY = 0
            If (Messenger.TicksLeft = 0) Then
                SetMessage(&H7D00, Parameters.GameOverMessage)
            End If
            State.GameWaitTime = 1
            State.DisableSound = True
        End If
        If (State.KeyShift) OrElse (State.KeyPressed = &H20) Then
            If (State.KeyVectorX <> 0) OrElse (State.KeyVectorY <> 0) Then
                If (CurrentBoard.MaxShots > 0) Then
                    If (World.Ammo > 0) Then
                        Count = 0
                        For I = 0 To ThingCount - 1
                            With CurrentBoard.Things(I)
                                If (ElementAt(.X, .Y).ID = ElementID.Bullet) Then
                                    If (.P1 = 0) Then
                                        Count += 1
                                    End If
                                End If
                            End With
                        Next
                        If (Count < CurrentBoard.MaxShots) Then
                            If SpawnProjectile(Library.GetElementFromID(ElementID.Bullet), T.X, T.Y, New Vector(State.KeyVectorX, State.KeyVectorY), False) Then
                                World.Ammo -= 1
                                StatusUpdate()
                                PlaySound(2, SoundBank.PlayerShoot)
                            End If
                        End If
                    Else
                        If (Alerts.NoAmmo) Then
                            SetMessage(&HC8, Parameters.NoAmmoMessage)
                            Alerts.NoAmmo = False
                        End If
                    End If
                Else
                    If (Alerts.NoShoot) Then
                        SetMessage(&HC8, Parameters.CantShootMessage)
                        Alerts.NoShoot = False
                    End If
                End If
            End If
            'State.KeyVectorX = 0
            'State.KeyVectorY = 0
        Else
            If (State.KeyVectorX <> 0) OrElse (State.KeyVectorY <> 0) Then
                TargetX = T.X + State.KeyVectorX
                TargetY = T.Y + State.KeyVectorY
                OldBoard = World.Board
                Interact(TargetX, TargetY, 0, State.KeyVectorX, State.KeyVectorY)
                T = CurrentBoard.Things(Index)
                If (State.KeyVectorX <> 0) OrElse (State.KeyVectorY <> 0) Then
                    TargetX = T.X + State.KeyVectorX
                    TargetY = T.Y + State.KeyVectorY
                    If (ElementAt(TargetX, TargetY).Floor) Then
                        MoveThing(0, TargetX, TargetY)
                        If (Not State.GameQuiet) Then
                            PlayerStepSound()
                        End If
                    End If
                End If
            End If
        End If

        Select Case State.KeyPressed
            Case &H54 'T
                If (Parameters.TorchesEnabled) AndAlso (World.TorchCycles <= 0) Then
                    If (World.Torches > 0) Then
                        If (CurrentBoard.IsDark) Then
                            World.Torches -= 1
                            World.TorchCycles = 200
                            StatusUpdate()
                            Radius(T.X, T.Y, RadiusType.Update)
                        Else
                            If (Alerts.NotDark) Then
                                SetMessage(&HC8, Parameters.NotDarkMessage)
                                Alerts.NotDark = False
                            End If
                        End If
                    Else
                        If (Alerts.NoTorch) Then
                            SetMessage(&HC8, Parameters.NoTorchesMessage)
                            Alerts.NoTorch = False
                        End If
                    End If
                End If
            Case &H1B, &H51 'esc, Q
                RaiseQuitGame()
                StopSound()
            Case &H53 'S
                RaiseEvent SaveGame(Me)
                State.GamePaused = True
            Case &H52 'R
                RaiseEvent LoadGame(Me)
                State.GamePaused = True
            Case &H50 'P
                If (World.Health > 0) Then
                    State.GamePaused = True
                    StatusUpdate()
                End If
            Case &H42 'B
                State.GameQuiet = Not State.GameQuiet
                StopSound()
                StatusUpdate()
                State.KeyPressed = &H20
            Case &H48 'H
                If (Parameters.HintsEnabled) Then
                    'ALL:HINT
                    SendLabel(0, OOPCodeSet(KnownCommand.All) & ":" & OOPCodeSet(KnownCommand.Hint), False)
                Else
                    ExecuteHelp("GAME")
                End If
            Case &H46 'F
                ExecuteHelp("ORDER")
            Case &HBF '?
                If (State.KeyShift) Then
                    RaiseEvent EnterCheat()
                    State.KeyPressed = 0
                End If
        End Select
        If (World.TorchCycles > 0) Then
            World.TorchCycles -= 1
            If (World.TorchCycles <= 0) Then
                Radius(T.X, T.Y, RadiusType.Update)
                PlaySound(3, SoundBank.TorchOut)
            End If
            If ((World.TorchCycles Mod 40) = 0) Then
                StatusUpdate()
            End If
        End If
        If (World.EnergyCycles > 0) Then
            World.EnergyCycles -= 1
            If (World.EnergyCycles = 10) Then
                PlaySound(9, SoundBank.EnergyOut)
            ElseIf (World.EnergyCycles = 0) Then
                ColorAt(T.X, T.Y) = State.PlayerElement.Color
                UpdateAt(T.X, T.Y)
            End If
        End If
        If (CurrentBoard.TimeLimit > 0) AndAlso (World.Health > 0) Then
            If (State.TimeLimitTicks >= Parameters.TimeTicksPerSecond) Then
                World.TimePassed += 1
                State.TimeLimitTicks -= Parameters.TimeTicksPerSecond
                If (CurrentBoard.TimeLimit - World.TimePassed = 10) Then
                    SetMessage(&HC8, Parameters.NoTimeMessage)
                    PlaySound(3, SoundBank.TimeLow)
                ElseIf (CurrentBoard.TimeLimit = World.TimePassed) Then
                    HarmThing(0)
                End If
            End If
            StatusUpdate()
        End If
        If (Parameters.RiverEnabled) Then
            MoveRiver(Index)
        End If
    End Sub

    Protected Sub ActPusher(ByVal Index As Integer)
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim V As Vector
        Dim T As Thing = CurrentBoard.Things(Index)

        TargetX = T.X + T.XStep
        TargetY = T.Y + T.YStep
        V = T.Vector
        If (Not ElementAt(TargetX, TargetY).Floor) Then
            Push(TargetX, TargetY, V)
            If (Not Parameters.KoopoBug) Then
                Index = CurrentBoard.Things.IndexOf(T)
            End If
            T = CurrentBoard.Things(Index)
        End If
        If (ElementAt(TargetX, TargetY).Floor) Then
            MoveThing(Index, TargetX, TargetY)
            PlaySound(2, SoundBank.Push)
        End If
    End Sub

    Protected Sub ActRoton(ByVal Index As Integer)
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim I As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        ' P2 and P3 are never used! maybe this was some diagnostic code
        T.P3 -= 1
        If (T.P3 < (-T.P2 Mod 10)) Then
            T.P3 = (T.P2 * 10) + Random(10)
        End If
        T.Vector = Seek(T.X, T.Y)
        If (T.P1 <= Random(10)) Then
            I = T.XStep
            T.XStep = -PosNeg(T.P2) * T.YStep
            T.YStep = PosNeg(T.P2) * I
        End If
        TargetX = T.X + T.XStep
        TargetY = T.Y + T.YStep
        With ElementAt(TargetX, TargetY)
            If (.Floor) Then
                MoveThing(Index, TargetX, TargetY)
            ElseIf (.ID = ElementID.Player) Then
                Attack(Index, TargetX, TargetY)
            End If
        End With
    End Sub

    Protected Sub ActRuffian(ByVal Index As Integer)
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim E As Element
        Dim T As Thing = CurrentBoard.Things(Index)

        If (T.XStep <> 0) OrElse (T.YStep <> 0) Then
            If (PlayerX = T.X) OrElse (PlayerY = T.Y) Then
                If (T.P1 >= Random(9)) Then
                    With Seek(T.X, T.Y)
                        T.XStep = .X
                        T.YStep = .Y
                    End With
                End If
            End If
            TargetX = T.X + T.XStep
            TargetY = T.Y + T.YStep
            E = ElementAt(TargetX, TargetY)
            If (E.ID = ElementID.Player) Then
                Attack(Index, TargetX, TargetY)
            ElseIf (E.Floor) Then
                MoveThing(Index, TargetX, TargetY)
                If (T.P2 + 8 <= Random(17)) Then
                    T.XStep = 0
                    T.YStep = 0
                End If
            Else
                T.XStep = 0
                T.YStep = 0
            End If
        Else
            If (T.P2 + 8 <= Random(17)) Then
                If (T.P1 >= Random(9)) Then
                    T.Vector = Seek(T.X, T.Y)
                Else
                    T.Vector = Rnd()
                End If
            End If
        End If
    End Sub

    Protected Sub ActScroll(ByVal Index As Integer)
        Dim I As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        I = ColorAt(T.X, T.Y) + 1
        If (I > &HF) Then
            I = 9
        End If
        ColorAt(T.X, T.Y) = I
        UpdateAt(T.X, T.Y)
    End Sub

    Protected Sub ActSegment(ByVal Index As Integer)
        Dim T As Thing = CurrentBoard.Things(Index)
        With T
            If (.Leader = -1) Then
                .Leader = -2
            ElseIf (.Leader = -2) Then
                ElementAt(T.X, T.Y) = Library.GetElementFromID(ElementID.Head)
            End If
        End With
    End Sub

    Protected Sub ActShark(ByVal Index As Integer)
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim V As Vector
        Dim E As Element
        Dim T As Thing = CurrentBoard.Things(Index)

        With T
            If .P1 >= Random(10) Then
                V = Seek(.X, .Y)
            Else
                V = Rnd()
            End If
            TargetX = V.X + .X
            TargetY = V.Y + .Y
            E = ElementAt(TargetX, TargetY)
            Select Case E.ID
                Case ElementID.Water, ElementID.Lava
                    MoveThing(Index, TargetX, TargetY)
                Case ElementID.Player
                    Attack(Index, TargetX, TargetY)
            End Select
        End With
    End Sub

    Protected Sub ActSlime(ByVal Index As Integer)
        Dim SourceX As Integer
        Dim SourceY As Integer
        Dim Color As Integer
        Dim Count As Integer
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim E As Element = Library.GetElementFromID(ElementID.Slime)
        Dim T As Thing = CurrentBoard.Things(Index)

        With T
            Count = 0
            If (.P1 >= .P2) Then
                Color = ColorAt(.X, .Y)
                T.P1 = 0
                SourceX = .X
                SourceY = .Y
                For I = 0 To 3
                    TargetX = SourceX + XVectorList4(I)
                    TargetY = SourceY + YVectorList4(I)
                    If (ElementAt(TargetX, TargetY).Floor) Then
                        If (Count = 0) Then
                            MoveThing(Index, TargetX, TargetY)
                            TileAt(SourceX, SourceY) = New Tile(Library.GetElementFromID(ElementID.Breakable), Color)
                            UpdateAt(SourceX, SourceY)
                        Else
                            SpawnThing(TargetX, TargetY, E, Color, E.Cycle, Nothing)
                            With CurrentBoard.Things(ThingCount - 1)
                                .P2 = T.P2
                            End With
                        End If
                        Count += 1
                    End If
                Next
                If (Count = 0) Then
                    RemoveThing(Index)
                    TileAt(SourceX, SourceY) = New Tile(Library.GetElementFromID(ElementID.Breakable), Color)
                    UpdateAt(SourceX, SourceY)
                End If
            Else
                .P1 += 1
            End If
        End With
    End Sub

    Protected Sub ActSpider(ByVal Index As Integer)
        Dim V As Vector
        Dim I As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        If (T.P1 <= Random(10)) Then
            V = Rnd()
        Else
            V = Seek(T.X, T.Y)
        End If
        If Not (ActSpiderMove(V.X, V.Y, Index)) Then
            I = (Random(2) << 1) - 1
            If Not (ActSpiderMove(V.Y * I, V.X * I, Index)) Then
                If Not (ActSpiderMove(-V.Y * I, -V.X * I, Index)) Then
                    ActSpiderMove(-V.X, -V.Y, Index)
                End If
            End If
        End If
    End Sub

    Protected Function ActSpiderMove(ByVal VectorX As Integer, ByVal VectorY As Integer, ByVal Index As Integer) As Boolean
        Dim Result As Boolean = False
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        TargetX = T.X + VectorX
        TargetY = T.Y + VectorY
        With ElementAt(TargetX, TargetY)
            If (.ID = ElementID.Web) Then
                MoveThing(Index, TargetX, TargetY)
                Result = True
            ElseIf (.ID = ElementID.Player) Then
                Attack(Index, TargetX, TargetY)
                Result = True
            End If
        End With
        Return Result
    End Function

    Protected Sub ActSpinningGun(ByVal Index As Integer)
        Dim Success As Boolean
        Dim E As Element
        Dim T As Thing = CurrentBoard.Things(Index)

        Success = False
        UpdateAt(T.X, T.Y)
        If (T.P2 >= &H80) Then
            E = Library.GetElementFromID(ElementID.Star)
        Else
            E = Library.GetElementFromID(ElementID.Bullet)
        End If
        If ((T.P2 And &H7F) > Random(9)) Then
            If (T.P1 >= Random(9)) Then
                If (AbsDiff(T.X, PlayerX) <= 2) Then
                    Success = SpawnProjectile(E, T.X, T.Y, New Vector(0, PosNeg(PlayerY - T.Y)), True)
                End If
                If (Not Success) AndAlso (AbsDiff(T.Y, PlayerY) <= 2) Then
                    Success = SpawnProjectile(E, T.X, T.Y, New Vector(PosNeg(PlayerX - T.X), 0), True)
                End If
            Else
                Success = SpawnProjectile(E, T.X, T.Y, Rnd, True)
            End If
        End If
    End Sub

    Protected Sub ActStar(ByVal Index As Integer)
        Dim E As Element
        Dim TargetX As Integer
        Dim TargetY As Integer
        Dim T As Thing = CurrentBoard.Things(Index)

        With T
            .P2 = (.P2 - 1) And 255
            If (.P2 > 0) Then
                If (.P2 Mod 2 = 0) Then
                    .Vector = Seek(.X, .Y)
                    TargetX = .X + .XStep
                    TargetY = .Y + .YStep
                    E = ElementAt(TargetX, TargetY)
                    If (E.ID = ElementID.Player) Or (E.ID = ElementID.Breakable) Then
                        Attack(Index, TargetX, TargetY)
                    Else
                        If (Not E.Floor) Then
                            Push(TargetX, TargetY, .Vector)
                            If (Not Parameters.KoopoBug) Then
                                Index = CurrentBoard.Things.IndexOf(T)
                            End If
                            T = CurrentBoard.Things(Index)
                        End If
                        If (E.Floor) OrElse (E.ID = ElementID.Water) OrElse (E.ID = ElementID.Lava) Then
                            MoveThing(Index, TargetX, TargetY)
                        End If
                    End If
                Else
                    UpdateAt(.X, .Y)
                End If
            Else
                RemoveThing(Index)
            End If
        End With
    End Sub

    Protected Sub ActStone(ByVal Index As Integer)
        Dim T As Thing = CurrentBoard.Things(Index)
        ColorAt(T.X, T.Y) = (ColorAt(T.X, T.Y) And &H70) + Random(7) + 9
        UpdateAt(T.X, T.Y)
    End Sub

    Protected Sub ActTiger(ByVal Index As Integer)
        Dim E As Element
        Dim Success As Boolean
        Dim T As Thing = CurrentBoard.Things(Index)

        With T
            If (.P2 >= &H80) Then
                E = Library.GetElementFromID(ElementID.Star)
            Else
                E = Library.GetElementFromID(ElementID.Bullet)
            End If
            If (.P2 Mod &H80 >= Random(10) * 3) Then
                If (AbsDiff(.X, PlayerX) <= 2) Then
                    Success = SpawnProjectile(E, .X, .Y, New Vector(0, PosNeg(PlayerY - .Y)), True)
                End If
                If (Not Success) AndAlso (AbsDiff(.Y, PlayerY) <= 2) Then
                    Success = SpawnProjectile(E, .X, .Y, New Vector(PosNeg(PlayerX - .X), 0), True)
                End If
            End If
        End With
        ActLion(Index)
    End Sub

    Protected Sub ActTransporter(ByVal Index As Integer)
        Dim T As Thing = CurrentBoard.Things(Index)
        UpdateAt(T.X, T.Y)
    End Sub

End Class
