﻿' RotonFileNew
'
' Code for initializing a new Environment based on gametype.


Partial Public NotInheritable Class File

    Public Shared Function Create(ByVal NewWorldType As EnvironmentGameType) As Environment
        Select Case NewWorldType
            Case EnvironmentGameType.ZZT
                Return CreateZZT()
            Case EnvironmentGameType.SuperZZT
                Return CreateSuperZZT()
        End Select
        Return Nothing
    End Function

    Private Shared Function CreateZZT() As Environment
        Dim Ret As New Environment

        With Ret
            .Type = EnvironmentGameType.ZZT
            .Library = LibraryDefault.ZZT
            .Parameters = EnvironmentParameters.ZZT
            .Boards.Add(CreateBlankBoard(.Parameters.BoardWidth, .Parameters.BoardHeight, .Library, .Parameters.MaxThings))
            .Boards(0).Clear()
            .World = New World
        End With

        Return Ret
    End Function

    Private Shared Function CreateSuperZZT() As Environment
        Dim Ret As New Environment

        With Ret
            .Type = EnvironmentGameType.SuperZZT
            .Library = LibraryDefault.SuperZZT
            .Parameters = EnvironmentParameters.SuperZZT
            .Boards.Add(CreateBlankBoard(.Parameters.BoardWidth, .Parameters.BoardHeight, .Library, .Parameters.MaxThings))
            .Boards(0).Clear()
            .World = New World
        End With

        Return Ret
    End Function

    Private Shared Function CreateBlankBoard(ByVal W As Integer, ByVal H As Integer, ByVal L As Library, ByVal Things As Integer) As Board
        Return New Board(W, H, Things, L.GetElementFromID(ElementID.BoardEdge), L.GetElementFromID(ElementID.Empty), L.GetElementFromID(ElementID.Player))
    End Function
End Class
