﻿' RotonHighScore
'
' Contains all code that handles high scores.

Imports System.IO



Public Structure HighScoreEntry
    Public Name As String
    Public Score As Integer

    Public Overrides Function ToString() As String
        Return Name & "," & Score
    End Function
End Structure

Public Class HighScoreList
    Public ReadOnly Count As Integer
    Public ReadOnly Scores() As HighScoreEntry
    Public ReadOnly NameLength As Integer

    Public Sub New(ByVal NewCount As Integer)
        Dim Index As Integer

        Count = NewCount
        If (NewCount > 0) Then
            ReDim Scores(Count - 1)
        End If

        For Index = 0 To Count - 1
            With Scores(Index)
                .Name = ""
                .Score = -1
            End With
        Next
    End Sub

    Public Sub Add(ByVal Name As String, ByVal Score As Integer)

    End Sub
End Class

Partial Public Class File

    Public Shared Sub SaveHighScores(ByVal Source As HighScoreList, ByVal Target As Stream, ByVal NameLength As Integer)
        Dim Writer As New ZZTBinaryWriter(Target)
        Dim Index As Integer

        For Index = 0 To Source.Count - 1
            With Source.Scores(Index)
                Writer.WriteZZTString(.Name, NameLength)
                Writer.WriteInt16(.Score)
            End With
        Next

        Writer.Flush()
    End Sub

    Public Shared Function LoadHighScores(ByVal Source As Stream, ByVal Count As Integer, ByVal NameLength As Integer) As HighScoreList
        Dim Reader As New ZZTBinaryReader(Source)
        Dim Index As Integer
        Dim Ret As HighScoreList

        Ret = New HighScoreList(Count)
        For Index = 0 To Count - 1
            With Ret.Scores(Index)
                .Name = Reader.ReadZZTString(NameLength)
                .Score = Reader.ReadInt16
            End With
        Next

        Return Ret
    End Function
End Class

Partial Public Class Environment

    Protected Sub LoadHighScores()
        Dim ScoreStream As Stream
        Dim ScoreFile As String

        ScoreFile = World.Name & "." & Parameters.HighScoreExtension
        ScoreStream = Cache.LoadFileStream(ScoreFile)
        If (ScoreStream.Length > 0) Then
            HighScores = File.LoadHighScores(ScoreStream, Parameters.HighScoreCount, Parameters.HighScoreLength)
        Else
            HighScores = New HighScoreList(Parameters.HighScoreCount)
        End If
    End Sub

    Protected Sub SaveHighScores()
        Dim ScoreStream As MemoryStream
        Dim ScoreFile As String

        ScoreFile = World.Name & "." & Parameters.HighScoreExtension
        ScoreStream = New MemoryStream
        File.SaveHighScores(HighScores, ScoreStream, Parameters.HighScoreLength)
        ScoreStream.Dispose()
    End Sub

End Class
