﻿' RotonInput
'
' Contains input interface that plugins can use to interact with Roton.


Public Interface Input
    Function GetKey() As Byte
    Function GetShift() As Boolean
    Sub Poll()
    Property Cheat As String
End Interface

Public Class InputNull
    Implements Input

    Public Function GetKey() As Byte Implements Input.GetKey
        Return 0
    End Function

    Public Function GetShift() As Boolean Implements Input.GetShift
        Return False
    End Function

    Public Sub Poll() Implements Input.Poll
        Return
    End Sub

    Public Property Cheat As String Implements Input.Cheat
        Get
            Return ""
        End Get
        Set(ByVal value As String)
            Return
        End Set
    End Property
End Class

Public Class InputForm
    Implements Input

    Private Keys(255) As Boolean
    Private KeysPressed(255) As Boolean
    Private Shift As Boolean
    Private Alt As Boolean
    Private Ctrl As Boolean
    Private CheatString As String
    Private PendingCheat As String

    Public Function GetKey() As Byte Implements Input.GetKey
        Dim Index As Integer
        For Index = 255 To 0 Step -1
            If KeysPressed(Index) Then
                Return CByte(Index)
            End If
        Next
        Return 0
    End Function

    Public Function GetShift() As Boolean Implements Input.GetShift
        Return Shift
    End Function

    Public Sub KeyDown(ByVal e As System.Windows.Forms.KeyEventArgs)
        Dim Val As Integer

        Val = e.KeyCode
        If (Val >= 0) AndAlso (Val <= 255) Then
            Keys(Val) = True
        End If

        UpdateControlKeys(e)
    End Sub

    Public Sub KeyUp(ByVal e As System.Windows.Forms.KeyEventArgs)
        UpdateControlKeys(e)
    End Sub

    Private Sub UpdateControlKeys(ByVal e As System.Windows.Forms.KeyEventArgs)
        Alt = ((e.KeyData And Windows.Forms.Keys.Alt) <> 0) Or (e.KeyCode = Windows.Forms.Keys.LMenu) Or (e.KeyCode = Windows.Forms.Keys.RMenu)
        Ctrl = ((e.KeyData And Windows.Forms.Keys.Control) <> 0) Or (e.KeyCode = Windows.Forms.Keys.ControlKey)
        Shift = ((e.KeyData And Windows.Forms.Keys.Shift) <> 0) Or (e.KeyCode = Windows.Forms.Keys.Shift)
    End Sub

    Public Sub Poll() Implements Input.Poll
        Dim Index As Integer
        For Index = 0 To 255
            KeysPressed(Index) = Keys(Index)
            Keys(Index) = False
        Next
        CheatString = PendingCheat
        PendingCheat = ""
    End Sub

    Public Property Cheat As String Implements Input.Cheat
        Get
            Return CheatString
        End Get
        Set(ByVal value As String)
            PendingCheat = value
        End Set
    End Property
End Class
