﻿' RotonParameters
'
' Contains the Parameters structure that contains information about the operation of the ZZT engine.



Public Class EnvironmentParameters
    Public AmmoPerPickup As Integer
    Public AmmoMessage As String
    Public BoardHeight As Integer
    Public BoardWidth As Integer
    Public BombActiveMessage As String
    Public BottomRowPutBug As Boolean
    Public BuggyPassages As Boolean
    Public CantShootMessage As String
    Public DarkMessage As String
    Public DeathColorMatch As Boolean
    Public DisplayWide As Boolean
    Public DoorLockedMessage As String
    Public DoorOpenMessage As String
    Public EnergizerMessage As String
    Public EnterAlert As Boolean
    Public FadeBlocksPerTick As Integer
    Public FadeChar As AnsiChar
    Public FakeWallMessage As String
    Public ForcePlayerColor As Boolean
    Public ForestMessage As String
    Public ForestToFloor As Boolean
    Public GameOverMessage As String
    Public GemMessage As String
    Public HealthPerGem As Integer
    Public HelpExtension As String
    Public HighScoreCount As Integer
    Public HighScoreExtension As String
    Public HighScoreLength As Integer
    Public HintsEnabled As Boolean
    Public InvisibleMessage As String
    Public KeyMessage As String
    Public KeyAlreadyMessage As String
    Public KoopoBug As Boolean
    Public LavaMessage As String
    Public MaxCommands As Integer
    Public MaxFlags As Integer
    Public MaxBoards As Integer
    Public MaxThings As Integer
    Public MessageCenterOffset As Integer
    Public MessageLines As Integer
    Public MultiMovement As Boolean
    Public NoAmmoMessage As String
    Public NotDarkMessage As String
    Public NoTimeMessage As String
    Public NoTorchesMessage As String
    Public OuchMessage As String
    Public PickupToFloor As Boolean
    Public PreKillObject As Boolean
    Public PressEnterMessage As String
    Public RiverEnabled As Boolean
    Public SavedGameExtension As String
    Public ScrollHeight As Integer
    Public ScrollWidth As Integer
    Public StoneMessage As String
    Public StonesEnabled As Boolean
    Public TimeTicksPerSecond As Integer
    Public TorchesEnabled As Boolean
    Public TorchMessage As String
    Public ViewHeight As Integer
    Public ViewWidth As Integer
    Public WaterMessage As String
    Public WorldExtension As String

    Public Shared Function Enumerate() As EnvironmentParameters()
        Dim Ret() As EnvironmentParameters = {
            ZZT(),
            SuperZZT()
        }
        Return Ret
    End Function

    Public Shared Function EnumerateWorldExtensions() As String()
        Dim Params() As EnvironmentParameters = Enumerate()
        Dim Index As Integer
        Dim Ret As New List(Of String)

        For Index = 0 To Params.Length - 1
            Ret.Add(Params(Index).WorldExtension)
        Next

        Return Ret.ToArray
    End Function

    Public Shared Function ZZT() As EnvironmentParameters
        Dim Ret As New EnvironmentParameters
        With Ret
            .AmmoPerPickup = 5
            .BoardHeight = 25
            .BoardWidth = 60
            .BottomRowPutBug = True
            .BuggyPassages = True
            .DeathColorMatch = True
            .DisplayWide = False
            .EnterAlert = False
            .FadeBlocksPerTick = 100
            .FadeChar = New AnsiChar(32, &H55)
            .ForcePlayerColor = True
            .ForestToFloor = False
            .HealthPerGem = 1
            .HelpExtension = "HLP"
            .HighScoreCount = 30
            .HighScoreExtension = "HI"
            .HighScoreLength = 50
            .HintsEnabled = False
            .KoopoBug = False
            .MaxBoards = 101
            .MaxCommands = 32
            .MaxFlags = 10
            .MaxThings = 151
            .MessageCenterOffset = 1
            .MessageLines = 1
            .MultiMovement = False
            .PickupToFloor = False
            .PreKillObject = True
            .RiverEnabled = False
            .SavedGameExtension = "SAV"
            .ScrollHeight = 19
            .ScrollWidth = 49
            .StonesEnabled = False
            .TimeTicksPerSecond = 72
            .TorchesEnabled = True
            .ViewHeight = 25
            .ViewWidth = 60
            .WorldExtension = "ZZT"


            .AmmoMessage = "Ammunition - %1 shots per container."
            .BombActiveMessage = "Bomb activated!"
            .CantShootMessage = "Can't shoot in this place!"
            .DarkMessage = "Room is dark - you need to light a torch!"
            .DoorLockedMessage = "The %1 door is locked!"
            .DoorOpenMessage = "The %1 door is now open."
            .EnergizerMessage = "Energizer - You are invincible"
            .FakeWallMessage = "A fake wall - secret passage!"
            .ForestMessage = "A path is cleared through the forest."
            .GameOverMessage = "Game over  -  Press ESCAPE"
            .GemMessage = "Gems give you health!"
            .InvisibleMessage = "You are blocked by an invisible wall."
            .KeyMessage = "You now have the %1 key."
            .KeyAlreadyMessage = "You already have a %1 key!"
            .NoAmmoMessage = "You don't have any ammo!"
            .NotDarkMessage = "Don't need torch - room is not dark!"
            .NoTimeMessage = "Running out of time!"
            .NoTorchesMessage = "You don't have any torches!"
            .OuchMessage = "Ouch!"
            .PressEnterMessage = "Press ENTER to select this"
            .TorchMessage = "Torch - used for lighting in the underground."
            .WaterMessage = "Your way is blocked by water."
        End With
        Return Ret
    End Function

    Public Shared Function SuperZZT() As EnvironmentParameters
        Dim Ret As New EnvironmentParameters
        With Ret
            .AmmoPerPickup = 20
            .BoardHeight = 80
            .BoardWidth = 96
            .BottomRowPutBug = False
            .BuggyPassages = False
            .DeathColorMatch = False
            .DisplayWide = True
            .EnterAlert = True
            .FadeBlocksPerTick = 50
            .FadeChar = New AnsiChar(32, &H55)
            .ForcePlayerColor = False
            .ForestToFloor = True
            .HealthPerGem = 10
            .HelpExtension = "HLP"
            .HighScoreCount = 30
            .HighScoreExtension = "HGS"
            .HighScoreLength = 60
            .HintsEnabled = True
            .KoopoBug = False
            .MaxBoards = 33
            .MaxCommands = 32
            .MaxFlags = 16
            .MaxThings = 129
            .MessageCenterOffset = 0
            .MessageLines = 2
            .MultiMovement = True
            .PickupToFloor = True
            .PreKillObject = False
            .RiverEnabled = True
            .SavedGameExtension = "SAV"
            .ScrollHeight = 23
            .ScrollWidth = 37
            .StonesEnabled = True
            .TimeTicksPerSecond = 72
            .TorchesEnabled = False
            .ViewHeight = 25
            .ViewWidth = 37
            .WorldExtension = "SZT"

            .AmmoMessage = "Ammunition:" & Chr(13) & "%1 shots"
            .BombActiveMessage = "Bomb activated!"
            .CantShootMessage = "Can't shoot" & Chr(13) & "in this place!"
            .DoorLockedMessage = "The %1 door" & Chr(13) & "is locked!"
            .DoorOpenMessage = "The %1 door" & Chr(13) & "is now open."
            .EnergizerMessage = "Shield:" & Chr(13) & "You are invincible"
            .FakeWallMessage = "A fake wall:" & Chr(13) & "Secret Passage!"
            .ForestMessage = "A path is cleared" & Chr(13) & "through the forest."
            .GameOverMessage = "Game over" & Chr(13) & "-- Press ESCAPE --"
            .GemMessage = "Gems give you health!"
            .InvisibleMessage = "You are blocked" & Chr(13) & "by an invisible wall."
            .KeyMessage = "You now have the" & Chr(13) & "%1 key."
            .KeyAlreadyMessage = "You already have a" & Chr(13) & "%1 key!"
            .LavaMessage = "Your way is" & Chr(13) & "blocked by lava."
            .NoAmmoMessage = "You don't have" & Chr(13) & "any ammo!"
            .NoTimeMessage = "Running out of time!"
            .OuchMessage = "Ouch!"
            .PressEnterMessage = "Press ENTER to select this"
            .StoneMessage = "You have found a" & Chr(13) & "Stone of Power!"
        End With
        Return Ret
    End Function
End Class

