﻿' RotonState
'
' Structure that contains information on the running state of an Environment.



Public Enum EnvironmentFadeMode As Integer
    None = 0
    FadeOut = 1
    FadeIn = 2
End Enum

Public Class EnvironmentGameState

    Public Structure FadePoint
        Public X As Integer
        Public Y As Integer

        Public Sub New(NewX As Integer, NewY As Integer)
            X = NewX
            Y = NewY
        End Sub
    End Structure

    Public ActIndex As Integer = 0
    Public BreakGameLoop As Boolean = False
    Public DisableSound As Boolean = False
    Public EditorMode As Boolean = False
    Public EnteringBoard As Boolean = False
    Public Execution As EnvironmentGameExecutionState = EnvironmentGameExecutionState.Init
    Public FadeIndex As Integer = -1
    Public FadeMatrix() As FadePoint
    Public FadeMode As EnvironmentFadeMode
    Public ForestMusicIndex As Integer = 0
    Public GamePaused As Boolean = False
    Public GamePausedBlink As Boolean = False
    Public GameQuiet As Boolean = False
    Public GameSpeed As Integer = 4
    Public GameTick As Integer = 0
    Public GameWaitTime As Integer = 0
    Public KeyArrow As Boolean = False
    Public KeyPressed As Byte = 0
    Public KeyShift As Boolean = False
    Public KeyVectorX As Integer = 0
    Public KeyVectorY As Integer = 0
    Public LastKeyVectorX As Integer = 0
    Public LastKeyVectorY As Integer = 0
    Public MainTimer As Integer = 0
    Public PlayerElement As Element
    Public QuitGame As Boolean = False
    Public QuitZZT As Boolean = False
    Public ScrollOwnerIndex As Integer = -1
    Public ScrollOwnerLink As String = ""
    Public SoundData As New Queue(Of Byte)
    Public SoundTicks As Integer = 0
    Public SoundPlaying As Boolean = False
    Public SoundPriority As Integer = 0
    Public StartBoard As Integer = 0
    Public TimeLimitTicks As Integer = 0
    Public TitleScreen As Boolean = False
    Public WorldLoaded As Boolean = False
End Class

