﻿' RotonThing
'
' Contains structure that describes the properties of a Thing.



Public Class CodeContainer
    Public Code As String
    Public Sub New(ByVal NewCode As String)
        Code = NewCode
    End Sub
End Class

Public Class Thing
    Public X As Integer
    Public Y As Integer
    Public XStep As Integer
    Public YStep As Integer
    Public Cycle As Integer
    Public P1 As Integer
    Public P2 As Integer
    Public P3 As Integer
    Public Follower As Integer
    Public Leader As Integer
    Public UnderElement As Element
    Public UnderColor As Integer
    Public Code As CodeContainer
    Public CurrentInstruction As Integer
    Public Length As Integer

    Public Sub New()
        SetDefaults()
    End Sub

    Public Sub New(ByVal SourceThing As Thing)
        MyBase.New()
        If (SourceThing Is Nothing) Then
            Exit Sub
        End If
        CopyFrom(SourceThing)
        X = -1
        Y = -1
    End Sub

    Public ReadOnly Property Flow As Vector
        Get
            Return New Vector(XStep, YStep)
        End Get
    End Property

    Public Property Vector As Vector
        Get
            Return New Vector(XStep, YStep)
        End Get
        Set(ByVal value As Vector)
            With value
                XStep = .X
                YStep = .Y
            End With
        End Set
    End Property

    Public Sub SetDefaults()
        X = -1
        Y = -1
        XStep = 0
        YStep = 0
        Cycle = 0
        P1 = 0
        P2 = 0
        P3 = 0
        Follower = -1
        Leader = -1
        UnderElement = Nothing
        UnderColor = 0
        Code = Nothing
        CurrentInstruction = -1
        Length = 0
    End Sub

    Public Sub CopyFrom(SourceThing As Thing)
        With SourceThing
            X = .X
            Y = .Y
            XStep = .XStep
            YStep = .YStep
            Cycle = .Cycle
            P1 = .P1
            P2 = .P2
            P3 = .P3
            Follower = .Follower
            Leader = .Leader
            UnderElement = .UnderElement
            UnderColor = .UnderColor
            If (.Code Is Nothing) Then
                Code = Nothing
            Else
                Code = New CodeContainer(.Code.Code)
            End If
            CurrentInstruction = .CurrentInstruction
            Length = .Length
        End With
    End Sub
End Class
