﻿' RotonTimer
'
' Contains code for timing. Each timer runs on its own thread.

Imports System.Diagnostics


Public Class Timer
    Public Event Tick(ByVal e As System.EventArgs)
    Private SW As Stopwatch
    Private IntervalTicks As Long
    Private NextTick As Long
    Private LastTick As Long
    Private MaxVariance As Long

    Public Sub New(ByVal NewIntervalUS As Integer)
        SW = New Stopwatch
        SW.Start()
        IntervalTicks = (Stopwatch.Frequency * CLng(NewIntervalUS)) \ CLng(1000000)
        If (IntervalTicks <= 0) Then
            IntervalTicks = 1
        End If
        Init()
    End Sub

    Public Sub Init()
        LastTick = SW.ElapsedTicks
        NextTick = LastTick + IntervalTicks
        MaxVariance = IntervalTicks * 3
    End Sub

    Public Sub Proc()
        Threaded()
    End Sub

    Private Sub Threaded()
        LastTick = SW.ElapsedTicks
        If ((NextTick + MaxVariance) < LastTick) Then
            NextTick = LastTick - MaxVariance
        End If
        Do While (NextTick < LastTick)
            NextTick += IntervalTicks
            RaiseEvent Tick(System.EventArgs.Empty)
        Loop
    End Sub
End Class
