﻿' RotonVector
'
' Contains structure which has information about vectors.


Public Structure Vector
    Public X As Integer
    Public Y As Integer

    Public Sub New(ByVal NewX As Integer, ByVal NewY As Integer)
        X = NewX
        Y = NewY
    End Sub

    Public Shared ReadOnly Property North As Vector
        Get
            Return New Vector(0, -1)
        End Get
    End Property

    Public Shared ReadOnly Property South As Vector
        Get
            Return New Vector(0, 1)
        End Get
    End Property

    Public Shared ReadOnly Property West As Vector
        Get
            Return New Vector(-1, 0)
        End Get
    End Property

    Public Shared ReadOnly Property East As Vector
        Get
            Return New Vector(1, 0)
        End Get
    End Property

    Public Shared ReadOnly Property Idle As Vector
        Get
            Return New Vector(0, 0)
        End Get
    End Property

    Public ReadOnly Property CW As Vector
        Get
            Return New Vector(-Y, X)
        End Get
    End Property

    Public ReadOnly Property CCW As Vector
        Get
            Return New Vector(Y, -X)
        End Get
    End Property

    Public ReadOnly Property Opp As Vector
        Get
            Return New Vector(-X, -Y)
        End Get
    End Property
End Structure

Partial Public Class Environment
    Protected Function Rnd() As Vector
        Dim X As Integer
        Dim Y As Integer
        X = RNG.Next(3) - 1
        If (X = 0) Then
            Y = (RNG.Next(2) << 1) - 1
        Else
            Y = 0
        End If
        Return New Vector(X, Y)
    End Function

    Protected Function RndNE() As Vector
        If (RNG.Next(2) = 0) Then
            Return Vector.North
        End If
        Return Vector.East
    End Function

    Protected Function RndNS() As Vector
        If (RNG.Next(2) = 0) Then
            Return Vector.North
        End If
        Return Vector.South
    End Function

    Protected Function RndP(ByVal InVector As Vector) As Vector
        If (RNG.Next(2) = 0) Then
            Return InVector.CW
        End If
        Return InVector.CCW
    End Function

    Protected Function Seek(ByVal SourceX As Integer, ByVal SourceY As Integer) As Vector
        Dim X As Integer
        Dim Y As Integer

        If (PlayerY = SourceY) OrElse (RNG.Next(2) = 1) Then
            X = PosNeg(PlayerX - SourceX)
            Y = 0
        End If

        If (X = 0) Then
            Y = PosNeg(PlayerY - SourceY)
        End If

        If (World.EnergyCycles > 0) Then
            X = -X
            Y = -Y
        End If

        Return New Vector(X, Y)
    End Function

    Protected ReadOnly Property PosNeg(ByVal InValue As Integer) As Integer
        Get
            If (InValue > 0) Then
                Return 1
            ElseIf (InValue < 0) Then
                Return -1
            End If
            Return 0
        End Get
    End Property
End Class
